<template>
  <span>
    <el-button type="primary" @click="visible = true"
      >
      {{ createIcon }}
    </el-button>
    <el-dialog
      width="800px"
      top="5vh"
      :visible.sync="visible"
      :show-close="false"
      :lock-scroll="true"
      append-to-body
      v-if="visible"
    >
      <el-form
        :ref="popup + ' form'"
        :rules="rules"
        :label-position="labelPosition"
        label-width="170px"
        :model="model"
        @submit="handleCreation"
        :validateOnRuleChange="false"
      >
        <popup
          :is="popup"
          :apiParams="apiParams"
          :ref="popup + ' popup'"
          :data="data"
          v-if="visible"
        />
        <div class="form-buttons">
          <el-button type="primary" @click="handleCreation">Save</el-button>
          <el-button type="warning" @click="clearForm(model)">Clear</el-button>
          <el-button type="danger" @click="cancelForm">Cancel</el-button>
        </div>
      </el-form>
    </el-dialog>
  </span>
</template>

<script>
import { mapState } from "vuex";
import EditRepoPopUp from "./EditRepoPopUp.vue";
import CreateRepoPopup from "./CreateRepoPopup.vue";
import AddProjectPopup from "./AddProjectPopup.vue";
import {
  clearForm,
  cancelForm,
  showSuccessAlert,
  showErrorAlert,
} from "../tools/functions";

export default {
  name: "GenericPopup",
  props: ["apiParams", "popup", "data"],
  components: {
    EditRepoPopUp,
    CreateRepoPopup,
    AddProjectPopup    
  },

  data() {
    return {
      visible: false,
      labelPosition: "right",
      rules: null,
      model: null,
      createIcon: this.popup.includes("Create") ? "Add repository" : this.popup.includes("Edit") ? "Edit" : "Create repository",
    };
  },
  updated() {
    const popupData = this.$refs[this.popup + " popup"];

    if (
      popupData != {} &&
      popupData != undefined &&
      (this.rules != popupData.rules || !this.model != popupData.model)
    ) {
      this.model = popupData.model;
      this.originalModel = JSON.parse(JSON.stringify(popupData.model));
      this.rules = popupData.rules;
    }
  },
  computed: {
    ...mapState({
      email: (state) => state.email,
    }),
  },
  methods: {
    handleCreation(event) {
      event.preventDefault();
      this.$refs[this.popup + " form"].validate((valid) => {
        if (valid)
          this.$refs[this.popup + " popup"]
            .postData()
            .then((res) => {
              if (res.status == 200) {
                this.visible = false;
                this.showSuccessAlert();
              } else if (res.status == 403) {
                this.$confirm("Something broke. Please try again.", "Error", {
                  type: "Error",
                });
              } else {
                let invalidFields = [];
                for (const key in res.data.errors) {
                  invalidFields.push(res.data.errors[key].extensions.field);
                }
                this.$confirm(
                  `The following fields are invalid format: ${invalidFields.join(
                    ", "
                  )}. Please re-enter.`,
                  "Error",
                  {
                    type: "Error",
                  }
                );
              }
            })
            .catch((err) => {
              console.log(err);
              this.showErrorAlert();
            });
      });
    },
    clearForm: function () {
      clearForm(this, this.originalModel);
    },
    cancelForm() {
      cancelForm(this, this.originalModel);
    },
    showSuccessAlert,
    showErrorAlert,
  },
};
</script>

<style>
.el-dropdown-link {
  cursor: pointer;
  color: #409eff;
}
.el-icon-arrow-down {
  font-size: 12px;
}
.el-select {
  width: 100%;
}
.left-form-item {
  display: flex;
}
.form-title {
  text-align: center;
}
.form-buttons {
  display: flex;
  justify-content: center;
}
</style>
